package sun.net.www.http;

import java.io.IOException;
import java.io.InputStream;
import java.io.FilterInputStream;

public class HttpCaptureInputStream extends FilterInputStream
{
    private HttpCapture capture;
    
    public HttpCaptureInputStream(InputStream in, HttpCapture capture) {
        super(in);
        this.capture = null;
        this.capture = capture;
    }
    
    @Override
    public int read() throws IOException {
        int read = super.read();
        this.capture.received(read);
        return read;
    }
    
    @Override
    public void close() throws IOException {
        try {
            this.capture.flush();
        }
        catch (IOException ex) {}
        super.close();
    }
    
    @Override
    public int read(byte[] b) throws IOException {
        int read = super.read(b);
        for (int i = 0; i < read; ++i) {
            this.capture.received((int)b[i]);
        }
        return read;
    }
    
    @Override
    public int read(byte[] b, int off, int len) throws IOException {
        int read = super.read(b, off, len);
        for (int i = 0; i < read; ++i) {
            this.capture.received((int)b[off + i]);
        }
        return read;
    }
}
